# all files / ol/ coordinate.js

100% Statements 84/84
90.91% Branches 20/22
100% Functions 15/15
100% Lines 84/84

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    3561×
    1×
    1×

    1×
    1×

    1×

    1×

    1×
    3×
    3×
    3×

    1×
    35×
    35×
    35×
    35×
    35×
    35×
    35×
    35×
    35×
    35×
    35×

    35×
    35×
    11×
    11×
    24×
    18×
    18×

    6×
    6×

    35×

    1×
    2×

    2×

    1×
    2×
    2×
    2×

    1×
    9×
    8×

    1×

    1×
    41×
    41×
    56×
    26×
    26×

    41×

    1×
    2×
    2×
    2×
    2×
    2×
    2×
    2×

    1×
    2×
    2×
    2×

    1×
    2×
    2×
    2×

    1×
    64×
    64×
    64×

    1×
    22×

    1×
    2×
    1×

    1×

    1×
    4×

    1×
    6×
    6×
    2×

    4×

     goog.provide('ol.Coordinate');
    goog.provide('ol.CoordinateFormatType');
    goog.provide('ol.coordinate');

    goog.require('goog.math');
    goog.require('goog.string');

    /**
     * A function that takes a {@link ol.Coordinate} and transforms it into a
     * `{string}`.
     *
     * @typedef {function((ol.Coordinate|undefined)): string}
     * @api stable
     */
    ol.CoordinateFormatType;

    /**
     * An array of numbers representing an xy coordinate. Example: `[16, 48]`.
     * @typedef {Array.<number>} ol.Coordinate
     * @api stable
     */
    ol.Coordinate;

    /**
     * Add `delta` to `coordinate`. `coordinate` is modified in place and returned
     * by the function.
     *
     * Example:
     *
     *     var coord = [7.85, 47.983333];
     *     ol.coordinate.add(coord, [-2, 4]);
     *     // coord is now [5.85, 51.983333]
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {ol.Coordinate} delta Delta.
     * @return {ol.Coordinate} The input coordinate adjusted by the given delta.
     * @api stable
     */
    ol.coordinate.add = function(coordinate, delta) {
      coordinate[0] += delta[0];
      coordinate[1] += delta[1];
      return coordinate;
    };

    /**
     * Calculates the point closest to the passed coordinate on the passed segment.
     * This is the foot of the perpendicular of the coordinate to the segment when
     * the foot is on the segment, or the closest segment coordinate when the foot
     * is outside the segment.
     *
     * @param {ol.Coordinate} coordinate The coordinate.
     * @param {Array.<ol.Coordinate>} segment The two coordinates of the segment.
     * @return {ol.Coordinate} The foot of the perpendicular of the coordinate to
     *     the segment.
     */
    ol.coordinate.closestOnSegment = function(coordinate, segment) {
      var x0 = coordinate[0];
      var y0 = coordinate[1];
      var start = segment[0];
      var end = segment[1];
      var x1 = start[0];
      var y1 = start[1];
      var x2 = end[0];
      var y2 = end[1];
      var dx = x2 - x1;
      var dy = y2 - y1;
      var along = (dx === 0 && dy === 0) ? 0 :
          ((dx * (x0 - x1)) + (dy * (y0 - y1))) / ((dx * dx + dy * dy) || 0);
      var x, y;
      if (along <= 0) {
        x = x1;
        y = y1;
      } else if (along >= 1) {
        x = x2;
        y = y2;
      } else {
        x = x1 + along * dx;
        y = y1 + along * dy;
      }
      return [x, y];
    };

    /**
     * Returns a {@link ol.CoordinateFormatType} function that can be used to format
     * a {ol.Coordinate} to a string.
     *
     * Example without specifying the fractional digits:
     *
     *     var coord = [7.85, 47.983333];
     *     var stringifyFunc = ol.coordinate.createStringXY();
     *     var out = stringifyFunc(coord);
     *     // out is now '8, 48'
     *
     * Example with explicitly specifying 2 fractional digits:
     *
     *     var coord = [7.85, 47.983333];
     *     var stringifyFunc = ol.coordinate.createStringXY(2);
     *     var out = stringifyFunc(coord);
     *     // out is now '7.85, 47.98'
     *
     * @param {number=} opt_fractionDigits The number of digits to include
     *    after the decimal point. Default is `0`.
     * @return {ol.CoordinateFormatType} Coordinate format.
     * @api stable
     */
    ol.coordinate.createStringXY = function(opt_fractionDigits) {
      return (
          /**
           * @param {ol.Coordinate|undefined} coordinate Coordinate.
           * @return {string} String XY.
           */
          function(coordinate) {
            return ol.coordinate.toStringXY(coordinate, opt_fractionDigits);
          });
    };

    /**
     * @private
     * @param {number} degrees Degrees.
     * @param {string} hemispheres Hemispheres.
     * @return {string} String.
     */
    ol.coordinate.degreesToStringHDMS_ = function(degrees, hemispheres) {
      var normalizedDegrees = goog.math.modulo(degrees + 180, 360) - 180;
      var x = Math.abs(Math.round(3600 * normalizedDegrees));
      return Math.floor(x / 3600) + '\u00b0 ' +
          goog.string.padNumber(Math.floor((x / 60) % 60), 2) + '\u2032 ' +
          goog.string.padNumber(Math.floor(x % 60), 2) + '\u2033 ' +
          hemispheres.charAt(normalizedDegrees < 0 ? 1 : 0);
    };

    /**
     * Transforms the given {@link ol.Coordinate} to a string using the given string
     * template. The strings `{x}` and `{y}` in the template will be replaced with
     * the first and second coordinate values respectively.
     *
     * Example without specifying the fractional digits:
     *
     *     var coord = [7.85, 47.983333];
     *     var template = 'Coordinate is ({x}|{y}).';
     *     var out = ol.coordinate.format(coord, template);
     *     // out is now 'Coordinate is (8|48).'
     *
     * Example explicitly specifying the fractional digits:
     *
     *     var coord = [7.85, 47.983333];
     *     var template = 'Coordinate is ({x}|{y}).';
     *     var out = ol.coordinate.format(coord, template, 2);
     *     // out is now 'Coordinate is (7.85|47.98).'
     *
     * @param {ol.Coordinate|undefined} coordinate Coordinate.
     * @param {string} template A template string with `{x}` and `{y}` placeholders
     *     that will be replaced by first and second coordinate values.
     * @param {number=} opt_fractionDigits The number of digits to include
     *    after the decimal point. Default is `0`.
     * @return {string} Formatted coordinate.
     * @api stable
     */
    ol.coordinate.format = function(coordinate, template, opt_fractionDigits) {
      if (coordinate) {
        return template
          .replace('{x}', coordinate[0].toFixed(opt_fractionDigits))
          .replace('{y}', coordinate[1].toFixed(opt_fractionDigits));
      } else {
        return '';
      }
    };

    /**
     * @param {ol.Coordinate} coordinate1 First coordinate.
     * @param {ol.Coordinate} coordinate2 Second coordinate.
     * @return {boolean} Whether the passed coordinates are equal.
     */
    ol.coordinate.equals = function(coordinate1, coordinate2) {
      var equals = true;
      for (var i = coordinate1.length - 1; i >= 0; --i) {
        if (coordinate1[i] != coordinate2[i]) {
          equals = false;
          break;
        }
      }
      return equals;
    };

    /**
     * Rotate `coordinate` by `angle`. `coordinate` is modified in place and
     * returned by the function.
     *
     * Example:
     *
     *     var coord = [7.85, 47.983333];
     *     var rotateRadians = Math.PI / 2; // 90 degrees
     *     ol.coordinate.rotate(coord, rotateRadians);
     *     // coord is now [-47.983333, 7.85]
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {number} angle Angle in radian.
     * @return {ol.Coordinate} Coordinate.
     * @api stable
     */
    ol.coordinate.rotate = function(coordinate, angle) {
      var cosAngle = Math.cos(angle);
      var sinAngle = Math.sin(angle);
      var x = coordinate[0] * cosAngle - coordinate[1] * sinAngle;
      var y = coordinate[1] * cosAngle + coordinate[0] * sinAngle;
      coordinate[0] = x;
      coordinate[1] = y;
      return coordinate;
    };

    /**
     * Scale `coordinate` by `scale`. `coordinate` is modified in place and returned
     * by the function.
     *
     * Example:
     *
     *     var coord = [7.85, 47.983333];
     *     var scale = 1.2;
     *     ol.coordinate.scale(coord, scale);
     *     // coord is now [9.42, 57.5799996]
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {number} scale Scale factor.
     * @return {ol.Coordinate} Coordinate.
     */
    ol.coordinate.scale = function(coordinate, scale) {
      coordinate[0] *= scale;
      coordinate[1] *= scale;
      return coordinate;
    };

    /**
     * Subtract `delta` to `coordinate`. `coordinate` is modified in place and
     * returned by the function.
     *
     * @param {ol.Coordinate} coordinate Coordinate.
     * @param {ol.Coordinate} delta Delta.
     * @return {ol.Coordinate} Coordinate.
     */
    ol.coordinate.sub = function(coordinate, delta) {
      coordinate[0] -= delta[0];
      coordinate[1] -= delta[1];
      return coordinate;
    };

    /**
     * @param {ol.Coordinate} coord1 First coordinate.
     * @param {ol.Coordinate} coord2 Second coordinate.
     * @return {number} Squared distance between coord1 and coord2.
     */
    ol.coordinate.squaredDistance = function(coord1, coord2) {
      var dx = coord1[0] - coord2[0];
      var dy = coord1[1] - coord2[1];
      return dx * dx + dy * dy;
    };

    /**
     * Calculate the squared distance from a coordinate to a line segment.
     *
     * @param {ol.Coordinate} coordinate Coordinate of the point.
     * @param {Array.<ol.Coordinate>} segment Line segment (2 coordinates).
     * @return {number} Squared distance from the point to the line segment.
     */
    ol.coordinate.squaredDistanceToSegment = function(coordinate, segment) {
      return ol.coordinate.squaredDistance(coordinate,
          ol.coordinate.closestOnSegment(coordinate, segment));
    };

    /**
     * Format a geographic coordinate with the hemisphere, degrees, minutes, and
     * seconds.
     *
     * Example:
     *
     *     var coord = [7.85, 47.983333];
     *     var out = ol.coordinate.toStringHDMS(coord);
     *     // out is now '47° 59′ 0″ N 7° 51′ 0″ E'
     *
     * @param {ol.Coordinate|undefined} coordinate Coordinate.
     * @return {string} Hemisphere, degrees, minutes and seconds.
     * @api stable
     */
    ol.coordinate.toStringHDMS = function(coordinate) {
      if (coordinate) {
        return ol.coordinate.degreesToStringHDMS_(coordinate[1], 'NS') + ' ' +
            ol.coordinate.degreesToStringHDMS_(coordinate[0], 'EW');
      } else {
        return '';
      }
    };

    /**
     * Format a coordinate as a comma delimited string.
     *
     * Example without specifying fractional digits:
     *
     *     var coord = [7.85, 47.983333];
     *     var out = ol.coordinate.toStringXY(coord);
     *     // out is now '8, 48'
     *
     * Example explicitly specifying 1 fractional digit:
     *
     *     var coord = [7.85, 47.983333];
     *     var out = ol.coordinate.toStringXY(coord, 1);
     *     // out is now '7.8, 48.0'
     *
     * @param {ol.Coordinate|undefined} coordinate Coordinate.
     * @param {number=} opt_fractionDigits The number of digits to include
     *    after the decimal point. Default is `0`.
     * @return {string} XY.
     * @api stable
     */
    ol.coordinate.toStringXY = function(coordinate, opt_fractionDigits) {
      return ol.coordinate.format(coordinate, '{x}, {y}', opt_fractionDigits);
    };

    /**
     * Create an ol.Coordinate from an Array and take into account axis order.
     *
     * Examples:
     *
     *     var northCoord = ol.coordinate.fromProjectedArray([1, 2], 'n');
     *     // northCoord is now [2, 1]
     *
     *     var eastCoord = ol.coordinate.fromProjectedArray([1, 2], 'e');
     *     // eastCoord is now [1, 2]
     *
     * @param {Array} array The array with coordinates.
     * @param {string} axis the axis info.
     * @return {ol.Coordinate} The coordinate created.
     */
    ol.coordinate.fromProjectedArray = function(array, axis) {
      var firstAxis = axis.charAt(0);
      if (firstAxis === 'n' || firstAxis === 's') {
        return [array[1], array[0]];
      } else {
        return array;
      }
    };